import 'dart:developer';

class Router {
  final List _routes = [];

  final String prefix;

  Router({this.prefix});

  Function getHandler(String path, String method) {
    for (var item in _routes) {
      if (item.path == path && item.method == method) {
        return item.handler;
      }
    }
  }

  void get(String path, Function handler) {
    if (prefix != null) {
      _routes.add(Entry(path: prefix + path, handler: handler, method: 'GET'));
    } else {
      _routes.add(Entry(path: path, handler: handler, method: 'GET'));
    }
  }

  void post(String path, Function handler) {
    _routes.add(Entry(path: path, handler: handler, method: 'POST'));
  }

  void put(String path, Function handler) {
    _routes.add(Entry(path: prefix + path, handler: handler, method: 'PUT'));
  }

  void delete(String path, Function handler) {
    _routes.add(Entry(path: prefix + path, handler: handler, method: 'DELETE'));
  }
}

class Entry {
  Function handler;
  String path;
  String method;

  Entry({this.handler, this.path, this.method});
}
