import 'dart:io';
import 'dart:isolate';
import 'dart:convert';

import './router.dart';

/// Checks if you are awesome. Spoiler: you are.
class Vlod {
  var router;

  Vlod({this.router});

  void listen(port) async {
    var server = await HttpServer.bind(InternetAddress.anyIPv6, port);

    server.listen((HttpRequest request) async {
      // get the handler function for the desired path
      var task = router.getHandler(request.uri.path, request.method);

      if (task == null) {
        request.response.statusCode = 404;
        return request.response.close();
      }

      // no content type
      if (request.method == 'GET') {
        var reformedRequest = Borp(
          response: request.response,
          headers: request.headers,
          uri: request.uri,
        );

        task(reformedRequest);
      }

      // json content type
      if (request.method == 'POST') {
        request.listen((contents) {
          var parsed = json.decode(utf8.decode(contents));

          var reformedRequest = Borp(
            response: request.response,
            body: parsed,
            headers: request.headers,
            uri: request.uri,
          );

          task(reformedRequest);
        });
      }
    });
  }
}

class Borp {
  var response;
  var body;
  var headers;
  var uri;

  Borp({this.response, this.body, this.headers, this.uri});
}
